# pi-transceiver-firmware

This is firmware that runs on an stm32. It receives data from a connected Raspberry Pi and transmits it via an si4463 transceiver chip. For more information, see [this article](https://www.scd31.com/posts/high-speed-balloon-comms).

## Compiling & Installing (Linux)

### Environment setup

First, install Rustup: https://rustup.rs

After that is installed, restart your terminal, or open a new one. Then run these commands:

```bash
rustup target add thumbv7em-none-eabihf # add our board architecture, if needed
cargo install flip-link # needed for building
cargo install cargo-dfu # needed for flashing
```

### Board setup
1. Connect the board to your computer via USB
2. Hold down the `flash` button
3. Momentarily press the `reset` button
4. Release the `flash` button

Finally, you're ready to compile and flash. This is a single command:

```
cargo dfu --release
```

This could take a few minutes, especially on an older system. If it complains about a permission issue, you may need to prepend `sudo` to the command. Once it completes, the board will reboot automatically. Congratulations - your firmware is now installed!
